library(lme4)
library(ggplot2)
library(lmtest)
# Read data

load("treeringdata.RData")



head(metadata)

trees<-subset(metadata,metadata$Standort!="N")
# plot(DproA~altitude,data=trees)
head(trees)


# GLMER
mod0<-glmer(cbind(Dichtschwankungen,Jahrringe - Dichtschwankungen) ~ 1 + (1|Tree.Code),data=trees,family="binomial")
mod1<-glmer(cbind(Dichtschwankungen,Jahrringe-Dichtschwankungen)~ dem + (1|Tree.Code),data=trees,family="binomial")
mod2<-glmer(cbind(Dichtschwankungen,Jahrringe-Dichtschwankungen)~ dem + I(dem^2) + (1|Tree.Code),data=trees,family="binomial")
anova(mod0,mod1,mod2)

# Quasibinomiales GLM
m0<-glm(cbind(Jahrringe - Dichtschwankungen,Dichtschwankungen)~ 1 ,data=trees,family="quasibinomial")
m1<-glm(cbind(Jahrringe - Dichtschwankungen,Dichtschwankungen)~ dem + I(dem^2) ,data=trees,family="binomial")
# p<0.001

anova(m1)
anova(m0,m1)
summary(m1)

## Pseudo R²
library(pscl)
pR2(m1)

n=204
lr.stat <- lrtest(m0, m1)
(1-exp(-as.numeric(lr.stat$stats[1])/n))/(1-exp(2*as.numeric(logLik(m1)/n)))
[1] 0.4445742
> mod1b$stats["R2"]
R2 
0.4445742 

## ammend 2016-09-27: why not just fit Rate of Ds ~ Height
mod2=lm(Dichtschwankungen/Jahrringe ~ dem + I(dem^2), data=trees)
mod3=lm(Dichtschwankungen/Jahrringe ~ dem + I(dem^2) + I(dem^3), data=trees)
summary(mod2)
anova(mod2, mod3)
qplot(x=dem, y=Dichtschwankungen/Jahrringe, data=trees)+geom_smooth()
# plot
df.pred=data.frame(dem=seq(min(trees$dem), max(trees$dem), by=1))
df.pred$y=predict(mod, newdata=df.pred)
ggplot(mapping=aes(x=dem, y=Dichtschwankungen/Jahrringe), data=trees)+
  geom_point()+
  geom_line(aes(x=dem, y=y), data=df.pred)



####plot Ds####
plot((Jahrringe-Dichtschwankungen)/Jahrringe~dem,data=trees,ylab=c("Index (1-D/years)"),xlab="Altitude [m]",pch=21,bg="lightgrey")
curve(plogis(coef(m1)[1]+coef(m1)[2]*x+coef(m1)[3]*I(x^2)),from=0,to=2500,add=TRUE,lty=2,lwd=2)
# min point
x=1:2500
y=plogis(coef(m1)[1]+coef(m1)[2]*x+coef(m1)[3]*I(x^2))
x[y==min(y)] # Minima

# Standardabweichung pro H?he
D=(trees$Jahrringe-trees$Dichtschwankungen)/trees$Jahrringe
stabw_h=tapply(D,trees$Standort,sd,na.rm=T)
# Wie viele B?ume pro Standort mit D?
D=(trees$Jahrringe-trees$Dichtschwankungen)/trees$Jahrringe
JaNein=D
JaNein[JaNein==1]=0
JaNein[JaNein>0]=1
sum_h=tapply(JaNein,trees$Standort,sum,na.rm=T)
sum_h

m1r<-glm(cbind(Jahrringe - Dichtschwankungen,Dichtschwankungen)~ 
           dem + I(dem^2) ,data=subset(trees,trees$Seite=="R")
         ,family="quasibinomial")
summary(m1r) # signif***
m1l<-glm(cbind(Jahrringe - Dichtschwankungen,Dichtschwankungen)~ 
           dem + I(dem^2) ,data=subset(trees,trees$Seite=="L")
         ,family="quasibinomial")
summary(m1l) # signif***
